import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { MonitorServiceGroup } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-09-13 14:19
 */
interface MonitorServiceGroupCU extends ConditionUtil<MonitorServiceGroupCU>{
    ID:FieldUtil<MonitorServiceGroupCU>;
    GROUP_NAME:FieldUtil<MonitorServiceGroupCU>;
    DELETED:FieldUtil<MonitorServiceGroupCU>;
    CREATE_TIME:FieldUtil<MonitorServiceGroupCU>;
    UPDATE_TIME:FieldUtil<MonitorServiceGroupCU>;
}

class MonitorServiceGroupCUImpl extends ConditionUtilImpl<MonitorServiceGroupCUImpl> implements MonitorServiceGroupCU{ 
    newInstance(): MonitorServiceGroupCUImpl {
        return new MonitorServiceGroupCUImpl();
    } 
    get ID(): FieldUtil<MonitorServiceGroupCU>{  
        return new FieldUtil('id','id','主键', this);
    }
    get GROUP_NAME(): FieldUtil<MonitorServiceGroupCU>{  
        return new FieldUtil('group_name','groupName','分组名', this);
    }
    get DELETED(): FieldUtil<MonitorServiceGroupCU>{  
        return new FieldUtil('deleted','deleted','deleted', this);
    }
    get CREATE_TIME(): FieldUtil<MonitorServiceGroupCU>{  
        return new FieldUtil('create_time','createTime','create_time', this);
    }
    get UPDATE_TIME(): FieldUtil<MonitorServiceGroupCU>{  
        return new FieldUtil('update_time','updateTime','update_time', this);
    }
}

@Singleton 
class MonitorServiceGroupMU extends TableUtilImpl<MonitorServiceGroupCU,MonitorServiceGroup>{ 
    tableName  = 'monitor_service_group';
    tableFields  = ['id','group_name','deleted','create_time','update_time'];
    modelFields  = ['id','groupName','deleted','createTime','updateTime'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): MonitorServiceGroupCU {
        return new MonitorServiceGroupCUImpl();
    }   

    static get ID(): FieldUtil<MonitorServiceGroupCU>{ 
        return new FieldUtil('id','id','主键', new MonitorServiceGroupCUImpl());
    }
    static get GROUP_NAME(): FieldUtil<MonitorServiceGroupCU>{ 
        return new FieldUtil('group_name','groupName','分组名', new MonitorServiceGroupCUImpl());
    }
    static get DELETED(): FieldUtil<MonitorServiceGroupCU>{ 
        return new FieldUtil('deleted','deleted','deleted', new MonitorServiceGroupCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<MonitorServiceGroupCU>{ 
        return new FieldUtil('create_time','createTime','create_time', new MonitorServiceGroupCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<MonitorServiceGroupCU>{ 
        return new FieldUtil('update_time','updateTime','update_time', new MonitorServiceGroupCUImpl());
    }

    get ID(): FieldUtil<MonitorServiceGroupCU>{ 
        return MonitorServiceGroupMU.ID;
    }
    get GROUP_NAME(): FieldUtil<MonitorServiceGroupCU>{ 
        return MonitorServiceGroupMU.GROUP_NAME;
    }
    get DELETED(): FieldUtil<MonitorServiceGroupCU>{ 
        return MonitorServiceGroupMU.DELETED;
    }
    get CREATE_TIME(): FieldUtil<MonitorServiceGroupCU>{ 
        return MonitorServiceGroupMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<MonitorServiceGroupCU>{ 
        return MonitorServiceGroupMU.UPDATE_TIME;
    }
}
export {MonitorServiceGroupMU, MonitorServiceGroupCU}
